#include <stdio.h>
#include "stack_0.h"
#include "map.h"

//Q19
/*@requires dn is a nul-terminated string
  @assigns nothing
  @ensures return the IP associated with dn */
int resolve(char *dn, map dns[]) {
  stack t;
  init_stack(&t);
  int i = 0;
  push(dn, &t);
  while (dn[i] != '\0') {
    if (dn[i] == '.') {
      push(&dn[i+1], &t);
    }
    i += 1;
  }
  int server = 0;
  while (server != -1 && !is_empty_stack(t)) 
    server = map_find(pop(&t), dns[server]);
  return server;
}

int main(int argc, char **argv) {
  map d[40];
  for (int i = 0; i < 40; i += 1)
    d[i] = map_empty();
  map_add("org", 1, &d[0]);
  map_add("com", 2, &d[0]);
  map_add("fr", 3, &d[0]);
  map_add("net", 4, &d[0]);

  // 1 : .org
  map_add("wikipedia.org", 5, &d[1]);
  map_add("gnu.org", 6, &d[1]);
  map_add("amnesty.org", 7, &d[1]);

  // 2 : .com
  map_add("google.com", 8, &d[2]);
  map_add("amazon.com", 9, &d[2]);

  // 3 : .fr
  map_add("gouv.fr", 10, &d[3]);
  map_add("amnesty.fr", 7, &d[3]);
  map_add("google.fr", 8, &d[3]);
  map_add("amazon.fr", 13, &d[3]);
  map_add("ensiie.fr", 34, &d[3]);

  // 4 : .net
  map_add("gandi.net", 14, &d[4]);
  map_add("iiens.net", 22, &d[4]);

  // 5 : wikipedia.org
  map_add("www.wikipedia.org", 15, &d[5]);
  map_add("fr.wikipedia.org", 16, &d[5]);
  map_add("en.wikipedia.org", 17, &d[5]);
  map_add("de.wikipedia.org", 18, &d[5]);
  
  // 6 : gnu.org
  map_add("www.gnu.org", 19, &d[6]);
  map_add("savannah.gnu.org", 20, &d[6]);

  // 7 : amnesty.org amnesty.fr
  map_add("www.amnesty.fr", 11, &d[7]);
  map_add("www.amnesty.org", 21, &d[7]);

  // 8 : google.com google.fr
  map_add("www.google.com", 12, &d[8]);
  map_add("www.google.fr", 22, &d[8]);
  map_add("maps.google.com", 23, &d[8]);
  map_add("maps.google.fr", 24, &d[8]);

  // 9 : amazon.com
  map_add("www.amazon.com", 25, &d[9]);
  map_add("aws.amazon.com", 26, &d[9]);
  
  // 10 : gouv.fr
  map_add("impots.gouv.fr", 27, &d[10]);
  map_add("culture.gouv.fr", 28, &d[10]);
  map_add("education.gouv.fr", 28, &d[10]);

  // 13 : amazon.fr
  map_add("www.amazon.fr", 30, &d[13]);
  map_add("support.amazon.fr", 31, &d[13]);

  // 14 : gandi.net
  map_add("www.gandi.net", 32, &d[14]);
  map_add("info.gandi.net", 33, &d[14]);

  // 15 : iiens.net
  map_add("www.iiens.net", 35, &d[15]);
  map_add("wiki.iiens.net", 35, &d[15]);
  map_add("webmail.iiens.net", 36, &d[15]);
  

  // 34 : ensiie.fr
  map_add("www.ensiie.fr", 37, &d[34]);
  map_add("auth.ensiie.fr", 38, &d[34]);
  map_add("aurionweb.ensiie.fr", 39, &d[34]);

  // 28 : culture.gouv.fr education.gouv.fr
  map_add("journeesdupatrimoine.culture.gouv.fr", 29, &d[28]);
  map_add("data.education.gouv.fr", 28, &d[28]);


  // ADD YOUR CODE HERE FOR QUESTION 20! 
  //Q20
  for (int k = 1; k < argc; k += 1) {
    int ans = resolve(argv[k], d);
    if (ans == -1)
      printf("IP of domain name %s could not be found.\n", argv[k]);
    else
      printf("IP of domain name %s is %d\n", argv[k], ans);
  }
  
  return 0;
}
