#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "map.h"

//Q9
typedef struct node *tree;

struct node {
  key k;
  value v;
  tree left;
  tree right;
};

//Q10
tree make_node(key k, value v) {
  tree res = malloc(sizeof (struct node));
  res->k = k;
  res->v = v;
  res->left = NULL;
  res->right = NULL;
  return res;
}

//Q11
map map_empty() {
  return NULL;
}

//Q12
value map_find(key k, map m) {
  tree t = m;
  while (t != NULL) {
    int c = strcmp(t->k, k);
    if (c == 0) return t->v;
    else if (c > 0) t = t->left;
    else t = t->right;
  }
  return -1;
}

//Q13
tree tree_add(key k, value v, tree t) {
  if (t == NULL) return make_node(k, v);
  int c = strcmp(t->k, k);
  if (c == 0) t->v = v;
  else if (c > 0) t->left = tree_add(k, v, t->left);
  else t->right = tree_add(k, v, t->right);
  return t;
}

//Q14
void map_add(key k, value v, map *d) {
  *d = tree_add(k, v, *d);
}

//Q15
void map_print(map d) {
  if (d == NULL) return;
  tree t = d;
  map_print(t->left);
  printf("\"%s\" -> %d\n", t->k, t->v);
  map_print(t->right);
}

//Q16
tree remove_root(tree t) {
  tree r;
  if (t->left == NULL) { r = t->right; free(t); }
  else if (t->left->right == NULL) {
    t->left->right = t->right;
    r = t->left;
    free(t);
  }
  else {
    tree prec = t->left;
    tree curr = t->left->right;
    while (curr->right != NULL) {
      prec = curr;
      curr = curr->right;
    }
    t->k = curr->k;
    t->v = curr->v;
    prec->right = curr->left;
    free(curr);
    r = t;
  }
  return r;
}

//Q17
tree remove_tree(key k, tree t) {
  if (t == NULL) return t;
  int c = strcmp(k, t->k);
  if (c == 0) return remove_root(t);
  if (c < 0) t->left = remove_tree(k, t->left);
  else t->right = remove_tree(k, t->right);
  return t;
}

//Q18
void map_remove(key k, map *m) {
  *m = remove_tree(k, *m);
}

