#ifndef __MAP_H
#define __MAP_H

//Q1
typedef char *key;
typedef int value;

//Q2
typedef void *map;

//Q3
/*@requires nothing
   assigns nothing
   ensures return an empty map */
map map_empty();

//Q4
/*@requires nothing
   assigns nothing
   ensures returns the value associated to the key 
     if such an association exists in the map
     returns -1 otherwise  */
value map_find(key, map);

//Q5
/*@requires d is a valid address
   assigns *d
   ensures add the association key,value in *d;
     if an association with the key already exists,
     it is overwritten       */
void map_add(key, value, map *d);

//Q6
/*@requires nothing
   assigns nothing
   ensures print the content of the map in ascending order
     of the keys        */
void map_print(map);

//Q7
/*@requires d is a valid address
   assigns *d
   ensures remove the association with the key in *d
     if it exists; otherwise do nothing */
void map_remove(key, map *d);

#endif
